Bug 995775 - mozjs crashes when using non-64k page size (32-bit etc...)
mozjs crashes when using non-64k page size (32-bit etc...)
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: mozjs17 (Show other bugs)
20
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Colin Walters
Fedora Extras Quality Assurance
:
: 1132537 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-08-10 20:46 EDT by Benjamin Herrenschmidt
Modified: 2015-06-29 08:15 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-06-29 08:15:46 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
powerpc32-non64k-page.patch (504 bytes, patch)
2014-08-22 14:03 EDT, Helmut Schlattl
no flags Details | Diff
mozjs17-spec-ppc.patch (870 bytes, patch)
2014-08-22 14:05 EDT, Helmut Schlattl
no flags Details | Diff
mozfailure.txt (1.85 KB, text/plain)
2014-08-22 14:08 EDT, Helmut Schlattl
no flags Details

  None (edit)
Description Benjamin Herrenschmidt 2013-08-10 20:46:24 EDT
Description of problem:

This also causes polkitd to die since it uses mozjs. The bug has to do
with hard coded page sizes at compile time. A fix is available

 https://bugzilla.mozilla.org/show_bug.cgi?id=840242

Which needs to be backported (I'm told it was backported to xulrunner but
 mozjs was missed)

Version-Release number of selected component (if applicable):


How reproducible:

100%. Use a 4k base page size kernel, run fc19 polkitd -> segfault

Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:
Comment 1 Gustavo Luiz Duarte 2013-08-13 16:15:48 EDT
Any change we can move to mozilla 24 for mozjs on Fedora? It has much better support for multiple page sizes and it should be the next ESR.
Comment 2 Colin Walters 2013-08-14 10:49:48 EDT
(In reply to Gustavo Luiz Duarte from comment #1)
> Any change we can move to mozilla 24 for mozjs on Fedora? It has much better
> support for multiple page sizes and it should be the next ESR.

Someone would have to just dive in and get a new standalone spidermonkey ESR release, and then gjs would have to be ported.  I'm not aware of anyone who is likely to do this in the near future, but I'd help review gjs changes if someone wanted to do it.
Comment 3 Andy Lawrence 2013-08-21 20:01:39 EDT
Is this perhaps what is causing the below?

[306275.869616] traps: polkitd[2239] general protection ip:7f646bc139d2 sp:7fff7f560440 error:0 in libmozjs-17.0.so[7f646badc000+3a7000]
[315567.773954] traps: polkitd[4803] general protection ip:7fd21433c9d2 sp:7fffd322d030 error:0 in libmozjs-17.0.so[7fd214205000+3a7000]
[324857.905651] traps: polkitd[7475] general protection ip:7fef173369d2 sp:7fff68698000 error:0 in libmozjs-17.0.so[7fef171ff000+3a7000]
[333851.798704] traps: polkitd[10017] general protection ip:7ffdd4b309d2 sp:7fff1a52cd30 error:0 in libmozjs-17.0.so[7ffdd49f9000+3a7000]
[343143.941242] traps: polkitd[12634] general protection ip:7f1d30c139d2 sp:7fff1c27d6c0 error:0 in libmozjs-17.0.so[7f1d30adc000+3a7000]
[353034.214826] traps: polkitd[15221] general protection ip:7f393eeb39d2 sp:7fff62bd4190 error:0 in libmozjs-17.0.so[7f393ed7c000+3a7000]
[362326.405240] traps: polkitd[17839] general protection ip:7fc6b9c3e9d2 sp:7fff4285f4a0 error:0 in libmozjs-17.0.so[7fc6b9b07000+3a7000]
Comment 4 Benjamin Herrenschmidt 2013-08-21 21:05:58 EDT
This is indeed one of the symptoms
Comment 5 Ingvar Hagelund 2013-08-28 16:29:17 EDT
A patch named mozbug746112-no-decommit-on-large-pages.patch was added in mozjs17-17.0.0-6 to address this on ppc64, at least that's how I read it. See bz #971519. Unfortunately, this breaks 32bit ppc. Removing the patch makes polkitd stop segfaulting in mozjs17 again on my G3 iBook.

Note that there are a few tests that fails in make check (I just skipped make check to get a working package). I guess someone should have a look at that as well.

Please exclude that patch mozbug746112-no-decommit-on-large-pages.patch on 32bit ppc.

Ingvar
Comment 6 Miloslav Trmač 2014-08-21 12:35:27 EDT
*** Bug 1132537 has been marked as a duplicate of this bug. ***
Comment 7 Helmut Schlattl 2014-08-22 14:00:27 EDT
Ingvar's adivce, also worked for me. 

I added a patch for mozjs17-17.0.0-11.fc21 to repair the large page problem on ppc32 (powerpc32-non64k-page.patch) and a further one for the spec-file (mozjs17-spec-ppc.patch), which also skips 'make check'

As already noticed by Ingvar, a few checks fail, if one would perform the check. The building errors of 'make -C js/src check' are in mozfailure.txt
Comment 8 Helmut Schlattl 2014-08-22 14:03:53 EDT
Created attachment 929721 [details]
powerpc32-non64k-page.patch

64k page shifts only on ppc64
Comment 9 Helmut Schlattl 2014-08-22 14:05:29 EDT
Created attachment 929722 [details]
mozjs17-spec-ppc.patch

Patch for the spec-file (skips checks on ppc)
Comment 10 Helmut Schlattl 2014-08-22 14:08:35 EDT
Created attachment 929723 [details]
mozfailure.txt

Check failures on powerpc32
Comment 11 Fedora End Of Life 2015-05-29 05:18:37 EDT
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 12 Fedora End Of Life 2015-06-29 08:15:46 EDT
Fedora 20 changed to end-of-life (EOL) status on 2015-06-23. Fedora 20 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.